// --------------------------------------
// Script : Atasco
// Autor  : MCC
// Fecha  : Octubre 2015
// Version: 1.0.0
// --------------------------------------

var canvas;                  // canvas del juego
var ctx;                     // contexto para graficar
var gctx;                    // fake canvas context for selection testing
var timer;

var stylePaddingLeft, stylePaddingTop, styleBorderLeft, styleBorderTop;

var soporteVibracion = "vibrate" in navigator;

var cars;
var frame;
var delta;
var moves;
var memoria;
var config    = {"w":0 , "dx":0, "dy":0};
var factor    = 1;
var nivel     = 0;
var goals     = 0;              // cantidad de autos liberar
var myAuto    = null            // auto seleccionado
var sound     = true;
var finJuego  = true;
var dibujando = false;

var BACK = 8;
var UNDO = 46;

var solucion = new Array();
var puzzle   = new Array();

puzzle[0] = [["h2",0],["v3",5],["v3",6],["v3",9],["r2",13],["v2",24],["h2",28],["h3",32]];
puzzle[1] = [["v2",0],["h3",3],["v2",9],["v3",11],["r2",12],["v2",16],["h3",18],["v2",26],["h2",28],["h2",30],["h2",33]];
puzzle[2] = [["r2",13],["v3",15],["h2",19],["v3",23],["v2",25],["h2",32]];
puzzle[3] = [["v3",0],["v3",3],["r2",13],["v2",20],["h3",21],["v2",29],["h3",32]];
puzzle[4] = [["h2",0],["v3",3],["v2",5],["v3",6],["v3",10],["r2",13],["v2",17],["h3",19],["v2",24],["h2",28],["h2",34]];
puzzle[5] = [["h2",0],["v2",3],["h2",6],["v3",10],["v3",11],["r2",13],["v3",15],["h2",18],["v2",20],["v2",24],["h3",33]];
puzzle[6] = [["v2",1],["h2",2],["v2",4],["v2",5],["v2",9],["r2",13],["h2",20],["v2",23],["v2",27]];
puzzle[7] = [["h2",3],["v3",5],["h2",8],["v2",10],["r2",12],["v2",14],["v2",15],["h2",18],["h2",22],["h2",24],["v2",26],["h3",27],["h2",30],["h3",33]];
puzzle[8] = [["v2",1],["h2",2],["h2",4],["v2",9],["h2",10],["r2",12],["v3",16],["v2",17],["v3",18],["h3",19],["v2",26],["v2",29]];
puzzle[9] = [["h2",0],["v2",2],["h2",4],["h2",6],["v3",11],["v3",12],["r2",13],["h3",19],["v2",27],["h2",28],["h2",30],["h2",34]];
puzzle[10] = [["v3",0],["h2",1],["v3",3],["r2",13],["v2",20],["h3",21],["v2",29],["h3",32]];
puzzle[11] = [["v2",0],["h2",1],["v3",5],["v3",8],["r2",12],["h3",21],["v2",28],["h3",30]];
puzzle[12] = [["h2",0],["h2",2],["v2",4],["v2",8],["v3",11],["v2",13],["r2",15],["v3",18],["h2",21],["v2",27],["h2",28],["h2",31],["h2",34]];
puzzle[13] = [["h2",0],["v2",2],["h2",10],["v2",12],["v2",13],["r2",14],["v2",16],["v2",17],["h2",20],["v2",26],["h2",28],["h2",30]];
puzzle[14] = [["h2",1],["h2",3],["h2",6],["h2",8],["v3",10],["v3",11],["v3",12],["v3",13],["r2",14],["v2",20],["v2",21],["h2",28],["h2",31],["h2",33]];
puzzle[15] = [["h2",0],["h2",2],["v2",4],["v3",5],["v2",6],["h2",8],["v2",13],["v3",14],["r2",15],["h3",21],["h2",30]];
puzzle[16] = [["v2",0],["h3",1],["h2",8],["h2",10],["r2",12],["v2",14],["h2",18],["v3",21],["h3",24],["v2",28],["v2",29],["h3",30]];
puzzle[17] = [["h2",0],["v2",2],["v3",3],["h2",6],["v3",12],["r2",13],["h3",19],["h2",25],["h3",30]];
puzzle[18] = [["v2",2],["h2",3],["v2",10],["v2",13],["r2",14],["h2",20],["v2",22],["h3",25]];
puzzle[19] = [["v2",0],["h3",3],["h2",7],["v2",9],["r2",12],["v2",14],["v3",17],["v2",26],["h2",27],["h3",33]];
puzzle[20] = [["h2",0],["v2",2],["v3",3],["v3",6],["r2",13],["h3",19],["h3",33]];
puzzle[21] = [["v2",2],["h3",3],["v2",6],["v3",9],["h2",10],["r2",13],["v2",19],["h2",22],["v2",24],["h2",26],["v2",29],["h3",31]];
puzzle[22] = [["h3",2],["v3",5],["v2",8],["h2",9],["r2",15],["v2",20],["v2",21],["h2",22],["h2",28],["h3",32]];
puzzle[23] = [["v2",2],["h2",3],["v2",7],["v2",12],["r2",14],["v2",16],["h2",19],["h3",24],["v2",28],["h2",30]];
puzzle[24] = [["h2",0],["v2",2],["h2",4],["h2",6],["v3",11],["v3",12],["r2",13],["v2",16],["h3",19],["v2",25],["v2",27],["h2",28],["h2",34]];
puzzle[25] = [["v2",1],["h3",3],["v2",6],["v2",9],["v3",10],["r2",13],["v2",17],["v2",18],["h3",19],["v2",26],["v2",29],["h2",33]];
puzzle[26] = [["v2",0],["h2",1],["v3",3],["h2",7],["r2",12],["v2",14],["v3",17],["h2",21],["v2",26],["h3",33]];
puzzle[27] = [["h3",0],["v2",3],["v3",8],["h2",10],["r2",12],["v2",18],["v2",19],["h2",21],["v3",23],["h3",26],["h2",30],["h2",32]];
puzzle[28] = [["h3",0],["v3",4],["v2",8],["r2",12],["v2",17],["v2",18],["h2",19],["h2",21],["h2",25],["v2",27],["v2",29],["h3",30]];
puzzle[29] = [["v3",0],["v2",2],["h3",3],["v2",9],["r2",13],["h2",18],["h2",20],["v3",23],["h2",30],["h2",32]];
puzzle[30] = [["h2",0],["h3",3],["v2",9],["h2",10],["v2",12],["r2",13],["v3",17],["v3",20],["h2",21],["h2",24],["h3",33]];
puzzle[31] = [["h2",0],["v3",2],["v2",3],["h2",4],["r2",12],["v2",18],["h2",19],["h2",21],["v3",23],["v2",27],["h2",30]];
puzzle[32] = [["v2",1],["v3",2],["h2",4],["r2",12],["v2",18],["h2",19],["h2",21],["v3",23],["h2",25],["v2",27],["v2",28],["h3",30]];
puzzle[33] = [["v2",0],["h3",3],["v2",9],["v3",11],["r2",12],["v2",16],["h3",18],["v2",21],["v2",26],["h2",28],["h2",30],["h2",33]];
puzzle[34] = [["v3",2],["h2",3],["v3",5],["v2",9],["r2",12],["v2",18],["h3",19],["h2",25],["v2",27],["h2",30]];
puzzle[35] = [["v3",0],["h3",1],["h2",4],["v2",7],["h2",8],["v3",11],["r2",14],["h3",18],["v2",21],["v2",26],["h2",28],["h2",30]];
puzzle[36] = [["h2",0],["v2",2],["h2",4],["h2",6],["v3",10],["v3",11],["v3",12],["r2",13],["h3",19],["v2",27],["h2",28],["h2",30],["h2",34]];
puzzle[37] = [["v2",0],["h3",3],["h2",7],["v2",9],["r2",12],["v2",14],["v3",17],["h2",21],["v2",26],["h2",27],["h3",33]];
puzzle[38] = [["v2",2],["h3",3],["v2",9],["r2",12],["v2",14],["v3",17],["h2",18],["h2",21],["v2",24],["v2",25],["h2",26],["h2",32]];
puzzle[39] = [["v3",0],["h2",1],["v2",4],["v2",7],["v2",8],["v3",11],["r2",15],["h3",18],["v2",21],["v2",26],["h2",28],["h2",30],["h2",33]];
puzzle[40] = [["h2",1],["v3",3],["v3",11],["v2",12],["r2",13],["v3",20],["h2",21],["h2",33]];
puzzle[41] = [["v2",2],["h3",3],["v3",9],["h2",10],["r2",13],["v2",19],["h2",22],["v2",24],["h2",26],["v2",29],["h3",31]];
puzzle[42] = [["h2",0],["v2",2],["v2",7],["h2",9],["v3",11],["v3",12],["r2",14],["v2",19],["h2",20],["v2",26],["v2",27],["h2",28],["h2",30]];
puzzle[43] = [["h3",0],["v3",3],["v2",4],["v2",5],["v2",8],["r2",12],["v2",16],["h2",18],["h2",20],["v2",23],["v2",24],["h2",27],["h3",33]];
puzzle[44] = [["v2",1],["h3",3],["v3",6],["v2",9],["v2",10],["r2",13],["h2",19],["h2",21],["v3",23],["v2",26],["h2",27],["h2",30]];
puzzle[45] = [["v2",2],["h3",3],["h2",6],["v2",10],["v2",12],["r2",13],["v2",19],["v2",20],["h2",21],["v3",23],["h2",27],["h3",31]];
puzzle[46] = [["h3",0],["v2",4],["v2",5],["v2",6],["h3",7],["v3",14],["r2",15],["v2",17],["h2",18],["v2",27],["h2",28],["h3",30]];
puzzle[47] = [["h2",1],["h2",3],["v3",5],["h3",6],["v2",14],["r2",15],["h2",18],["v2",21],["h2",22],["h3",24],["h2",32],["h2",34]];
puzzle[48] = [["v3",1],["v2",3],["h2",4],["v2",6],["v2",10],["v2",11],["r2",14],["v2",18],["h2",19],["v2",21],["v2",23],["v2",26],["h3",33]];
puzzle[49] = [["h2",1],["v2",3],["h2",4],["h2",7],["v2",11],["v3",14],["r2",15],["h2",18],["v3",23],["v2",24],["h2",31],["h2",33]];
puzzle[50] = [["h2",0],["v2",2],["v2",3],["v2",6],["h2",10],["r2",13],["v2",15],["v2",16],["h2",18],["v2",20],["h2",27],["v2",29],["h2",30],["h3",32]];
puzzle[51] = [["v2",1],["v3",2],["h2",4],["h2",10],["r2",12],["r2",15],["v3",17],["v2",18],["h3",19],["h2",25],["v2",27],["h2",34]];
puzzle[52] = [["v2",0],["h2",1],["v3",3],["v2",4],["r2",12],["v2",14],["v2",19],["h3",21],["v2",26],["h2",27],["v2",29],["h2",30]];
puzzle[53] = [["v2",0],["h3",2],["v2",5],["r2",12],["v3",14],["v2",15],["v2",16],["v2",17],["h2",18],["v2",24],["v2",25],["h3",27],["h2",32],["h2",34]];
puzzle[54] = [["v2",0],["h3",1],["v3",4],["h3",7],["r2",12],["v2",14],["v2",15],["h2",22],["h3",26],["v2",29],["h2",33]];
puzzle[55] = [["v3",0],["v2",1],["v2",2],["h2",3],["v3",5],["v2",10],["r2",13],["v2",15],["v2",20],["h2",22],["v2",27],["h3",30]];
puzzle[56] = [["h2",0],["v2",2],["v3",6],["v2",7],["v3",10],["v3",11],["r2",14],["h3",19],["v2",27],["h2",28],["h2",30],["h2",34]];
puzzle[57] = [["v3",0],["h2",1],["v2",3],["v2",4],["v2",7],["v3",11],["r2",14],["h3",18],["v2",21],["v2",26],["h2",28],["h2",30],["h2",33]];
puzzle[58] = [["v2",0],["h2",1],["h2",4],["h2",7],["h2",9],["v3",11],["r2",12],["v2",16],["v2",19],["h2",20],["v2",26],["v2",27],["h2",28],["h2",30]];
puzzle[59] = [["v2",1],["h2",2],["v2",4],["v2",8],["v2",11],["r2",12],["h2",18],["v2",20],["h2",21],["v3",23],["v2",24],["h2",27],["h3",32]];
puzzle[60] = [["v2",0],["h2",1],["v2",3],["v3",5],["v2",7],["r2",14],["v2",16],["h2",18],["v3",20],["v2",21],["h2",28],["h2",30],["h2",33]];
puzzle[61] = [["v2",0],["h2",2],["v3",4],["h3",7],["r2",12],["v2",14],["v2",15],["h2",22],["h3",26],["v2",29],["h3",32]];
puzzle[62] = [["v2",1],["h2",2],["h2",4],["h2",8],["v2",11],["r2",12],["v2",14],["v2",15],["h2",22],["v2",24],["h2",26],["v2",28],["v2",29],["h3",31]];
puzzle[63] = [["v2",0],["h2",1],["v2",3],["h2",4],["v2",11],["r2",12],["r2",15],["v2",14],["h2",18],["v2",21],["h2",22],["v2",24],["h2",25],["h3",33]];
puzzle[64] = [["v2",0],["h2",1],["h2",3],["v2",8],["h3",9],["r2",12],["v3",15],["v2",17],["v2",18],["h2",19],["v2",22],["v2",25],["v2",29],["h3",32]];
puzzle[65] = [["v3",0],["v2",1],["h3",2],["v2",5],["v3",10],["r2",13],["v2",17],["h2",18],["v2",20],["h3",27],["h2",32],["h2",34]];
puzzle[66] = [["h3",0],["v2",3],["v2",4],["h2",7],["v3",12],["r2",13],["v2",15],["v2",20],["h2",22],["h2",27],["v2",29],["h3",30]];
puzzle[67] = [["h2",1],["h2",3],["v2",5],["v2",8],["v2",9],["r2",12],["v3",17],["v3",18],["v2",20],["h2",21],["h2",27],["h2",31],["h3",33]];
puzzle[68] = [["v2",0],["h3",1],["v2",8],["v3",9],["h2",10],["r2",12],["v2",17],["h2",18],["v2",20],["v2",25],["v2",29],["h3",32]];
puzzle[69] = [["v2",0],["v2",1],["h2",2],["v3",5],["r2",12],["r2",15],["v3",14],["h2",18],["v2",21],["h2",22],["v2",24],["v2",28],["h3",31]];
puzzle[70] = [["v2",0],["v2",1],["h2",2],["h2",4],["v3",8],["h2",10],["r2",12],["r2",15],["v3",17],["h2",18],["v2",21],["v2",24],["h2",25],["h3",33]];
puzzle[71] = [["v2",1],["h2",2],["h2",4],["v2",8],["h2",9],["v3",11],["r2",12],["v3",18],["h2",19],["v2",21],["h2",28],["h3",31]];
puzzle[72] = [["v2",0],["v3",2],["h2",4],["v2",10],["v3",11],["r2",12],["v2",19],["h3",20],["v2",24],["v2",27],["h2",28],["h2",31]];
puzzle[73] = [["h3",1],["h2",4],["v2",8],["h2",9],["v2",11],["r2",12],["r2",15],["v2",18],["h2",19],["v2",21],["v2",22],["v3",23],["h2",25],["h2",30],["h3",32]];
puzzle[74] = [["h3",0],["v2",3],["v2",4],["v2",5],["h2",6],["r2",12],["v2",15],["v2",18],["h2",19],["h2",22],["v2",26],["h2",27],["v2",29],["h2",30]];
puzzle[75] = [["h2",1],["h2",3],["v3",8],["v2",9],["r2",12],["h2",18],["v2",21],["h2",22],["v2",24],["h2",25],["v2",29],["h3",31]];
puzzle[76] = [["h3",2],["v3",5],["v2",8],["r2",15],["h2",18],["v2",20],["v2",21],["v2",24],["v2",25],["h2",28],["h3",32]];
puzzle[77] = [["v2",1],["h2",2],["h2",4],["v2",9],["h2",10],["r2",12],["v3",16],["v3",18],["h3",19],["v3",23],["v2",26],["h2",33]];
puzzle[78] = [["h2",0],["v2",2],["h2",4],["h2",10],["r2",12],["v2",14],["v2",17],["v3",18],["h2",21],["h2",25],["v2",27],["v2",29],["h2",31]];
puzzle[79] = [["h3",0],["v2",3],["v3",5],["v2",8],["r2",12],["r2",15],["v2",19],["h2",20],["h2",22],["v2",24],["v2",26],["h2",28],["h2",34]];
puzzle[80] = [["v3",0],["v2",2],["h2",3],["v2",5],["h2",9],["r3",13],["v3",16],["v2",17],["h2",18],["v2",21],["v2",25],["h3",33]];
puzzle[81] = [["v3",0],["v2",1],["h2",4],["h2",9],["v3",11],["r3",13],["v2",16],["h2",18],["v2",20],["v2",21],["h2",28],["h2",31],["h2",33]];
puzzle[82] = [["h3",2],["v3",5],["v3",8],["h2",9],["r2",12],["v2",15],["h2",22],["h3",25],["v2",28],["h3",31]];
puzzle[83] = [["h3",1],["v3",4],["v2",5],["h2",8],["r2",12],["v2",14],["v3",17],["v3",18],["h2",21],["v2",25],["h3",26],["h2",32],["h2",34]];
puzzle[84] = [["v3",3],["h2",4],["v3",11],["r3",12],["v2",18],["v2",20],["h2",21],["h3",30]];
puzzle[85] = [["h3",0],["v3",5],["h3",6],["v3",12],["r3",13],["v2",19],["h2",20],["h2",22],["v2",26],["v2",27],["h2",28],["h2",30]];
puzzle[86] = [["v2",0],["h3",1],["v2",4],["v3",5],["h3",7],["v2",14],["r2",15],["h2",18],["v3",21],["h2",28],["h3",30]];
puzzle[87] = [["v3",1],["h2",2],["h2",4],["v2",6],["h2",9],["v3",11],["r3",14],["v2",18],["h2",19],["v2",21],["v2",26],["h2",28],["h2",30],["h2",33]];
puzzle[88] = [["h3",0],["v3",5],["r3",12],["v2",18],["v2",19],["v2",20],["h3",21],["v2",27],["h2",28],["h2",31]];
puzzle[89] = [["v2",1],["h3",3],["v2",9],["v3",10],["v3",12],["r2",13],["h3",19],["v3",23],["v2",26],["h2",33]];
puzzle[90] = [["v2",2],["h2",3],["v2",5],["v2",9],["v2",10],["r3",12],["v2",17],["v3",18],["h2",19],["h2",21],["v2",25],["h2",28],["h2",34]];
puzzle[91] = [["h2",0],["v2",2],["v2",3],["v2",6],["h2",10],["r3",14],["v2",17],["h3",18],["v3",22],["h2",24],["v2",29],["h2",30],["h2",32]];
puzzle[92] = [["v3",0],["h2",1],["h3",3],["v2",7],["v3",11],["r2",14],["v2",16],["h3",18],["v2",26],["h3",27],["h2",30],["h2",34]];
puzzle[93] = [["v2",2],["h3",3],["h2",6],["v2",9],["v3",10],["v3",11],["v3",12],["r2",13],["v3",19],["h2",20],["h2",32],["h2",34]];
puzzle[94] = [["v3",3],["h2",4],["h2",6],["v2",10],["r3",12],["v2",20],["h2",21],["v3",23],["v2",24],["h3",32]];
puzzle[95] = [["v2",1],["h2",2],["h2",4],["h3",8],["v3",11],["v3",12],["r3",13],["h2",19],["h2",21],["v2",26],["v2",27],["h2",28],["h2",30]];
puzzle[96] = [["v3",0],["h3",1],["v3",5],["h2",7],["r2",13],["v2",15],["h2",18],["v3",20],["h2",27],["h3",33]];
puzzle[97] = [["v3",2],["h3",3],["v2",9],["h2",10],["r2",12],["v2",18],["h2",20],["v2",22],["v3",23],["h3",25],["h2",30],["h3",32]];
puzzle[98] = [["v2",1],["v2",3],["h2",4],["h2",10],["v3",12],["r3",13],["v2",16],["h2",19],["v3",23],["v2",26],["h2",27],["h2",30]];
puzzle[99] = [["h2",0],["v2",2],["v3",3],["v3",6],["r2",13],["h3",21],["h3",24],["v2",28],["v2",29],["h3",30]];
puzzle[100] = [["h2",0],["h2",3],["v3",5],["h2",6],["h2",8],["v2",10],["r3",12],["v2",15],["v3",18],["h2",22],["h2",25],["h2",27],["h3",31],["h2",34]];
puzzle[101] = [["v3",0],["v2",1],["h3",2],["v2",5],["h2",8],["v3",10],["r2",13],["v2",17],["h2",18],["v2",20],["h3",27],["h3",31]];
puzzle[102] = [["v3",0],["v2",1],["v2",3],["h2",4],["r3",13],["v2",16],["h2",18],["v2",20],["v3",23],["h2",27],["h2",30],["h3",32]];
puzzle[103] = [["v2",1],["h2",2],["v2",4],["v2",5],["v2",9],["r3",12],["v2",17],["h2",18],["v2",20],["h2",21],["v2",24],["v2",27],["h2",31]];
puzzle[104] = [["v2",0],["h3",1],["v3",4],["h3",7],["r2",12],["v2",14],["v2",15],["h2",22],["h3",26],["v2",29],["h3",32]];
puzzle[105] = [["v2",0],["h2",1],["v3",3],["v2",4],["v2",5],["v2",8],["r2",12],["v2",16],["v3",17],["h3",19],["h3",26],["h3",33]];
puzzle[106] = [["v3",0],["v2",1],["h3",2],["v2",9],["v3",10],["r2",13],["v3",17],["h2",20],["v2",26],["h2",27],["h2",30],["h2",34]];
puzzle[107] = [["h2",0],["v2",2],["h2",4],["h2",6],["v3",11],["v3",12],["r2",13],["v2",16],["h3",19],["v2",27],["h2",28],["h2",30],["h2",34]];
puzzle[108] = [["h3",0],["v2",4],["v2",5],["v2",6],["h3",7],["v2",14],["r2",15],["v2",17],["h2",18],["v3",21],["h2",28],["h3",30]];
puzzle[109] = [["h2",0],["h3",2],["v3",5],["v2",6],["h3",8],["r2",13],["h2",18],["v2",20],["h2",22],["v2",24],["h3",27],["h2",31],["h3",33]];
puzzle[110] = [["h3",2],["v3",5],["v2",8],["h2",9],["r2",12],["v3",15],["v3",18],["h2",19],["h2",28],["h3",33]];
puzzle[111] = [["h3",0],["v2",3],["v3",5],["v2",6],["h2",7],["v3",14],["r2",15],["h2",18],["h3",27],["h3",32]];
puzzle[112] = [["v2",2],["h2",3],["v2",5],["v3",10],["r3",12],["v2",15],["v3",17],["v3",18],["h2",19],["v2",25],["h2",27],["h2",32],["h2",34]];
puzzle[113] = [["v2",0],["h2",2],["v2",4],["v2",5],["v2",8],["r2",15],["v2",17],["h3",18],["v3",21],["v2",26],["h2",28],["h2",30]];
puzzle[114] = [["h3",1],["v3",5],["v2",9],["v2",10],["r2",12],["v2",18],["h2",19],["h2",21],["v2",26],["v2",27],["h2",28],["h2",30]];
puzzle[115] = [["h2",0],["v3",2],["v2",4],["v3",5],["r2",15],["v3",21],["h2",22],["v2",24],["h2",25],["h2",31]];
puzzle[116] = [["h2",0],["h2",2],["v2",4],["v2",5],["h2",6],["v3",12],["r2",15],["v2",17],["h3",20],["v2",26],["v2",27],["h2",28],["h2",30]];
puzzle[117] = [["v3",0],["v2",1],["h2",2],["h2",4],["h2",8],["v3",10],["r2",13],["v2",15],["h3",18],["v3",23],["v2",26],["h2",27],["h2",33]];
puzzle[118] = [["h3",0],["v2",3],["v3",5],["v2",6],["h2",7],["v3",14],["r2",15],["v2",21],["h2",22],["h2",31],["h2",33]];
puzzle[119] = [["h2",0],["v2",2],["h2",4],["h2",10],["r2",12],["v2",14],["v2",17],["v3",18],["h2",21],["h2",25],["v2",27],["v2",29],["h2",31]];

// ---------------------------------------
// CARGA LAS IMAGENES
// ---------------------------------------

var fondo  = new Image();
var autosv = new Array();
var autosh = new Array();

fondo.src = "images/fondo.png";

for (var i=0; i<9; i++)
{
    autosv[i] = new Image();
    autosh[i] = new Image();
    autosv[i].src = "images/vertical/" + i + ".gif";
    autosh[i].src = "images/horizontal/" + i + ".gif";
}

document.onselectstart = function () { return false; }

// ---------------------------------------
// CLASE AUTO
// ---------------------------------------

function Auto(id, x, y, w, h, ok, v, img)
{
    this.id = id;
    this.x  = x;
    this.y  = y;
    this.w  = w;
    this.h  = h;
    this.x0 = x;
    this.y0 = y;
    this.dx = 0;
    this.dy = 0;
    this.ok = ok;
    this.vertical = v;
    this.imagen   = img;
}

// ---------------------------------------
// INICIALIZA EL CANVAS
// ---------------------------------------

function init()
{
    clearInterval(timer);

    canvas = document.getElementById("canvas");
    ctx = canvas.getContext("2d");

    // FIXES MOUSE CO-ORDINATE PROBLEMS WHEN THERE'S A BORDER OR PADDING
    if (document.defaultView && document.defaultView.getComputedStyle)
    {
        stylePaddingLeft = Math.floor(document.defaultView.getComputedStyle(canvas, null)['paddingLeft'], 10)     || 0;
        stylePaddingTop  = Math.floor(document.defaultView.getComputedStyle(canvas, null)['paddingTop'], 10)      || 0;
        styleBorderLeft  = Math.floor(document.defaultView.getComputedStyle(canvas, null)['borderLeftWidth'], 10) || 0;
        styleBorderTop   = Math.floor(document.defaultView.getComputedStyle(canvas, null)['borderTopWidth'], 10)  || 0;
    }

    var gcnv = document.createElement("canvas");
    gcnv.height = canvas.height;
    gcnv.width  = canvas.width;
    gctx = gcnv.getContext("2d");
    gctx.fillStyle = "black";

    cars      = new Array();
    memoria   = new Array();
    goals     = 0;
    myAuto    = null;
    dibujando = false;
    finJuego  = false;
    factor    = canvas.height / fondo.height;

    config.w  = Math.ceil(72 * factor);
    config.dx = Math.ceil(46 * factor);
    config.dy = Math.ceil(64 * factor);

    var modelos = new Array();

    modelos["v2"] = {"w" : 1, "h" : 2};
    modelos["v3"] = {"w" : 1, "h" : 3};
    modelos["h2"] = {"w" : 2, "h" : 1};
    modelos["h3"] = {"w" : 3, "h" : 1};
    modelos["r2"] = {"w" : 2, "h" : 1};
    modelos["r3"] = {"w" : 3, "h" : 1};

    var a = 0; // contador de autos
    var b = 0; // contador de camiones

    for (var i=0; i < puzzle[nivel].length; i++)
    {
        var k = puzzle[nivel][i][0];
        var c = puzzle[nivel][i][1]%6;
        var f = Math.floor(puzzle[nivel][i][1]/6);

        var imagen = new Image();

        switch (k)
        {
            case "r2": imagen = autosh[7]; goals++; break;
            case "r3": imagen = autosh[8]; goals++; break;
            case "v2": imagen = autosv[a];   if (++a == 3) a = 0; break;
            case "h2": imagen = autosh[a];   if (++a == 3) a = 0; break;
            case "v3": imagen = autosv[3+b]; if (++b == 4) b = 0; break;
            case "h3": imagen = autosh[3+b]; if (++b == 4) b = 0; break;
        }

        var x  = c * config.w + config.dx;
        var y  = f * config.w + config.dy;
        var w  = modelos[k].w * config.w;
        var h  = modelos[k].h * config.w;
        var v  = k.charAt(0) == "v";
        var ok = k.charAt(0) == "r";

        cars[i] = new Auto(i, x, y, w, h, ok, v, imagen);
    }

    document.getElementById("level").innerHTML  = nivel%40+1;
    document.getElementById("moves").innerHTML  = 0;
    document.getElementById("record").innerHTML = (solucion[nivel] != undefined) ? solucion[nivel].length/2 : 0;
    document.getElementById("demo").setAttribute("disabled", (solucion[nivel] != undefined) ? "enabled" : "disabled");

    habilitar(true);

    dibujarFantasma();
    dibujar();

    if (sound)
    {
        sndinicio.pause();
        sndinicio.currentTime = 0;
        sndinicio.play();
    }
}

// ---------------------------------------
// DIBUJA EL TABLERO
// ---------------------------------------

function dibujar()
{
    dibujando = true;

    ctx.clearRect(0, 0, canvas.width, canvas.height);
    ctx.drawImage(fondo, 0, 0, fondo.width*factor, fondo.height * factor);

    for (var i = 0; i < cars.length; i++)
    {
        var w  = cars[i].imagen.width  * factor;
        var h  = cars[i].imagen.height * factor;
        var dx = Math.floor((cars[i].w - w) / 2);
        var dy = Math.floor((cars[i].h - h) / 2);

        ctx.drawImage(cars[i].imagen, cars[i].x + dx, cars[i].y + dy, w, h);
    }

    dibujando = false;
}

// ---------------------------------------
// DIBUJA LA ANIMACION DE SALIDA
// ---------------------------------------

function salir()
{
    myAuto.x += 2;
    dibujar();

    if (myAuto.x > canvas.width)
    {
        clearInterval(timer);
        myAuto = null;

        if (--goals == 0) finalizarJuego();
        else
        {
            habilitar(true);
            dibujarFantasma();
        }
    }
}

// ---------------------------------------
// HABITA O DESHABILITA EL CANVAS
// ---------------------------------------

function habilitar(valor)
{
    if (valor)
    {
        canvas.onmousemove = myMove;
        canvas.onmousedown = myDown;
        canvas.onmouseup   = myUp;
        canvas.onmouseout  = myUp;
        window.onkeydown   = doKeyDown;

        canvas.addEventListener('touchstart', myDown, false);
        canvas.addEventListener('touchmove',  myMove, false);
        canvas.addEventListener('touchend',   myUp,   false);
    }
    else
    {
        canvas.onmousemove = null;
        canvas.onmousedown = null;
        canvas.onmouseup   = null;
        canvas.onmouseout  = null;
        window.onkeydown   = null;

        canvas.removeEventListener('touchstart', myDown, false);
        canvas.removeEventListener('touchmove',  myMove, false);
        canvas.removeEventListener('touchend',   myUp,   false);
    }
}

// ---------------------------------------
// FINALIZA EL JUEGO
// ---------------------------------------

function finalizarJuego()
{
    if (sound) sndaplauso.play();

    finJuego = true;
    habilitar(false);

    // GUARDA EL RECORD
    if (solucion[nivel] == undefined || memoria.length < solucion[nivel].length)
    {
        solucion[nivel] = new Array();
        solucion[nivel] = memoria.slice(0);
        document.getElementById("demo").setAttribute("disabled", "enabled");
        document.getElementById("record").innerHTML = solucion[nivel].length/2;

        guardarSolucion();
        alertar("Rush Hour Classic","Felicitaciones, ha logrado un nuevo record!");
    }
}

// ---------------------------------------
// PRESIONO EL BOTON DEL MOUSE
// ---------------------------------------

function myDown(e)
{
    myAuto = null;

    if (e.type == "touchstart" && e.targetTouches.length > 1) deshacer();
    else
    {
        var p = getPosicion(e);

        gctx.clearRect(0, 0, canvas.width, canvas.height);

        for (var i = 0; i < cars.length; i++)
        {
            gctx.fillRect(cars[i].x, cars[i].y, cars[i].w, cars[i].h);

            // GET IMAGE DATA AT THE MOUSE X, Y PIXEL
            var imageData = gctx.getImageData(p.x, p.y, 1, 1);

            // CHECK IF THE MOUSE PIXEL EXISTS
            if (imageData.data[3] > 0)
            {
                myAuto    = cars[i];
                myAuto.x0 = myAuto.x;       // GUARDO LAS COORDENADAS DE BACKUP
                myAuto.y0 = myAuto.y;       // GUARDO LAS COORDENADAS DE BACKUP
                myAuto.dx = p.x - myAuto.x;
                myAuto.dy = p.y - myAuto.y;

                canvas.style.cursor = "grabbing";

                // GUARDO LA IMAGEN FANTASMA PARA DETECTAR COLISIONES
                dibujarFantasma(i);

                return;
            }
        }
    }
}

// ---------------------------------------
// MUEVO EL AUTO
// ---------------------------------------

function myMove(e)
{
    var p = getPosicion(e);

    var imageData = gctx.getImageData(p.x, p.y, 1, 1);

    if (myAuto == null) canvas.style.cursor = (imageData.data[3] > 0) ? "pointer" : "";
    else if (imageData.data[3] > 0) myUp();
    else
    {
        var x1 = myAuto.x;
        var y1 = myAuto.y;

        if (myAuto.vertical) myAuto.y = p.y - myAuto.dy;
        else                 myAuto.x = p.x - myAuto.dx;

        if (esColision())
        {
            myAuto.x  = x1;
            myAuto.y  = y1;
            myAuto.dx = p.x - myAuto.x;
            myAuto.dy = p.y - myAuto.y;
        }
        else if (!dibujando) dibujar();
    }
}

// ---------------------------------------
// SUELTO EL BOTON DEL MOUSE
// ---------------------------------------

function myUp()
{
    if (myAuto == null) return;

    if (myAuto.vertical) myAuto.y = Math.round(Math.max(0, myAuto.y - config.dy) / config.w) * config.w + config.dy;
    else                 myAuto.x = Math.round(Math.max(0, myAuto.x - config.dx) / config.w) * config.w + config.dx;

    // SI EL AUTO ESTA FUERA DEL CANVAS VUELVE A SU POSICION INICIAL
    if (myAuto.x < 0 || myAuto.y < 0 || myAuto.x + myAuto.w > canvas.width || myAuto.y + myAuto.h > canvas.height || esColision())
    {
        myAuto.x = myAuto.x0;
        myAuto.y = myAuto.y0;
    }
    else
    {
        // GUARDA EL MOVIMIENTO EN LA MEMORIA
        var mv = (myAuto.vertical) ? myAuto.y0 - myAuto.y : myAuto.x0 - myAuto.x;

        if (mv != 0)
        {
            guardarMemoria(myAuto.id, Math.round(mv/config.w));
            document.getElementById("moves").innerHTML = memoria.length/2;
        }
    }

    canvas.style.cursor = "";
    dibujar();

    // VERIFICO SI EL AUTO ROJO ESTA LIBERADO
    if (myAuto.ok && (myAuto.x + myAuto.w) / config.w >= 6)
    {
        habilitar(false);
        guardarMemoria(myAuto.id, -Math.round(myAuto.w/config.w)-2);

        clearInterval(timer);
        timer = setInterval(salir, 20);
        if (sound) sndarranque.play();
        if (soporteVibracion) window.navigator.vibrate([100,100,100,100,500]);
    }
    else
    {
        myAuto = null;
        dibujarFantasma();
    }
}

// ---------------------------------------
// GUARDA LA MEMORIA
// ---------------------------------------

function guardarMemoria(id, n)
{
    var k = memoria.length;

    if (k > 0 && memoria[k-2] == id)
    {
        memoria[k-1] += n;
        if (memoria[k-1] == 0)
        {
            memoria.pop();
            memoria.pop();
        }
    }
    else if (n != 0)
    {
        memoria.push(id);
        memoria.push(n);
    }
}

// ---------------------------------------
// DIBUJA EL FANTASMA DE LA IMAGEN
// ---------------------------------------

function dibujarFantasma(i)
{
    // GUARDO LA IMAGEN FANTASMA PARA DETECTAR MOUSE OVER
    gctx.clearRect(0, 0, canvas.width, canvas.height);

    if (i != undefined)
    {
        gctx.beginPath();
        gctx.rect(config.dx-2, config.dy-2, config.w*6+4, config.w*6+4);
        gctx.stroke();
    }

    for (var j = 0; j < cars.length; j++)
        if (i!=j) gctx.fillRect(cars[j].x+1, cars[j].y+1, cars[j].w-2, cars[j].h-2);
}

// ---------------------------------------
// DEVUELVE TRUE SI ES COLISION
// ---------------------------------------

function esColision()
{
    var imageData = gctx.getImageData(myAuto.x+1, myAuto.y+1, myAuto.w-2, myAuto.h-2);

    for (var i=3; i < imageData.data.length; i += 4)
        if (imageData.data[i] > 0) return true;

    return false;
}

// ---------------------------------------
// INICIA EL MODO DEMO
// ---------------------------------------

function demo()
{
    if (solucion[nivel] == undefined)
    {
        alertar("Rush Hour Classic","Solucin no disponible");
        return;
    }

    init();
    habilitar(false);
    finJuego = true;

    memoria = solucion[nivel].slice(0);

    var k = memoria.shift(); // ID DE AUTO
    var n = memoria.shift(); // MOVIMIENTO
    var paso = Math.floor(10 * factor);
    var dist = Math.floor(config.w / paso);

    myAuto = cars[k];
    frame  = Math.abs(n) * paso;
    delta  = n < 0 ? dist : -dist;
    moves  = 0;

    document.getElementById("moves").innerHTML = (++moves);

    clearInterval(timer);
    timer = setInterval(animacion, 30);
}

// ---------------------------------------
// ANIMACION
// ---------------------------------------

function animacion()
{
    if (frame-- >= 0)
    {
        if (myAuto.vertical) myAuto.y += delta;
        else myAuto.x += delta;
    }
    else if (memoria.length > 0)
    {
        // CORRIGE LA POSICION FINAL DEL AUTO
        if (myAuto.ok && myAuto.x > config.w*6); // SAQUE EL AUTO ROJO NO HAGO NADA
        else if (myAuto.vertical) myAuto.y = Math.round(Math.max(0, myAuto.y - config.dy) / config.w) * config.w + config.dy;
        else                      myAuto.x = Math.round(Math.max(0, myAuto.x - config.dx) / config.w) * config.w + config.dx;

        document.getElementById("moves").innerHTML = (++moves);

        // BUSCA EL SIGUIENTE MOVIMIENTO
        var k = memoria.shift(); // ID DE AUTO
        var n = memoria.shift(); // MOVIMIENTO
        var paso = Math.floor(10 * factor);
        var dist = Math.floor(config.w / paso);

        myAuto = cars[k];
        frame  = Math.abs(n) * paso;
        delta  = n < 0 ? dist : -dist;
    }
    else clearInterval(timer);

    dibujar();
}

// ---------------------------------------
// EJECUTA EL PHP PARA GUARDAR LA SOLUCION
// ---------------------------------------

function guardarSolucion()
{
    console.log("solucion[" + nivel + "] = [" + memoria.toString() + "];");

    if (document.location.toString().indexOf("file") >= 0) return;

    var ajax = new XMLHttpRequest();
    ajax.open('GET', 'php/atasco.php?nivel=' + nivel + '&solucion=' + memoria.toString(), true);
    ajax.send(null);
    ajax.onreadystatechange=function()
    {
        if (ajax.readyState==4) console.log("Solucin guardada exitosamente");
    }
}

// ---------------------------------------
// CAPTURA EL EVENTO DE PRESIONAR UN TECLA
// ---------------------------------------

function doKeyDown(e)
{
    var tecla = e.keyCode;

    if (tecla == UNDO || tecla == BACK) deshacer();

    return (tecla!=UNDO && tecla!=BACK);
}

// --------------------------------------------
// DESHACE EL ULTIMO MOVIMIENTO
// --------------------------------------------

function deshacer()
{
    if (finJuego) return;
    if (memoria.length == 0) return;

    myAuto = null;

    var n = memoria.pop();
    var k = memoria.pop();

    if (cars[k].ok && cars[k].x > canvas.width) goals++;

    // ASIGNA Y CORRIGE LA POSICION FINAL DEL AUTO
    if (cars[k].vertical)
    {
        cars[k].y += Math.floor(config.w*n);
        cars[k].y  = Math.round(Math.max(0, cars[k].y - config.dy) / config.w) * config.w + config.dy;
    }
    else
    {
        cars[k].x += Math.floor(config.w*n);
        cars[k].x  = Math.round(Math.max(0, cars[k].x - config.dx) / config.w) * config.w + config.dx;
    }

    cars[k].x0 = cars[k].x;
    cars[k].y0 = cars[k].y;

    document.getElementById("moves").innerHTML = memoria.length/2;

    dibujarFantasma();
    dibujar();
    if (sound) sndatras.play();
}

// --------------------------------------------
// DEVUELVE LA POSICION DEL MOUSE O TOUCH
// --------------------------------------------

function getPosicion(e)
{
    var element = e.target || e.srcElement;
    var offsetX = 0;
    var offsetY = 0;

    var mx = (e.type == "touchstart" || e.type == "touchmove") ? e.targetTouches[0].pageX : e.pageX;
    var my = (e.type == "touchstart" || e.type == "touchmove") ? e.targetTouches[0].pageY : e.pageY;

    e.preventDefault();

    if (element.offsetParent)
    {
        do
        {
            offsetX += element.offsetLeft;
            offsetY += element.offsetTop;
        } while (element = element.offsetParent);
    }

    // Add padding and border style widths to offset
    offsetX += stylePaddingLeft;
    offsetY += stylePaddingTop;
    offsetX += styleBorderLeft;
    offsetY += styleBorderTop;

    var x = Math.floor(mx-offsetX);
    var y = Math.floor(my-offsetY);

    return {"x":x, "y":y};
}